#include "gazebo_imu_plugin.hh"

using namespace gazebo;
GZ_REGISTER_SENSOR_PLUGIN(GazeboIMUPlugin)

/////////////////////////////////////////////////
GazeboIMUPlugin::GazeboIMUPlugin() : SensorPlugin()
{
    // Simulated accesleration (my_imu)
    m_acc_x = 0;
    m_acc_y = 0;
    m_acc_z = 0;

    // Simulated angular velocity (my_imu)
    m_omega_x = 0;
    m_omega_y = 0;
    m_omega_z = 0;
}

/////////////////////////////////////////////////
GazeboIMUPlugin::~GazeboIMUPlugin()
{ 
}   

/////////////////////////////////////////////////
void GazeboIMUPlugin::Load(sensors::SensorPtr _sensor, sdf::ElementPtr /*_sdf*/)
{   
  // Get the parent sensor.
  this->parentSensor =
    //boost::shared_dynamic_cast<sensors::ImuSensor>(_sensor);
		boost::dynamic_pointer_cast<sensors::ImuSensor>(_sensor);

  // Make sure the parent sensor is valid.
  if (!this->parentSensor)
  { 
    gzerr << "ContactPlugin requires a IMU-Sensor.\n";
    return;
  } 

  // Connect to the sensor update event.
  this->updateConnection = this->parentSensor->ConnectUpdated(
      boost::bind(&GazeboIMUPlugin::OnUpdate, this));

  // Make sure the parent sensor is active.
  this->parentSensor->SetActive(true);
}

/////////////////////////////////////////////////
void GazeboIMUPlugin::OnUpdate()
{
}
