#ifndef _GAZEBO_IMU_PLUGIN_HH_
#define _GAZEBO_IMU_PLUGIN_HH_

#include <string>

#include <gazebo/gazebo.hh>
#include <gazebo/sensors/sensors.hh>

namespace gazebo
{

//  typedef const boost::shared_ptr<const collision_map_creator_msgs::msgs::Imu> CollisionMapRequestPtr;

  /// \brief An example plugin for a contact sensor.
  class GazeboIMUPlugin : public SensorPlugin
  {         
    /// \brief Constructor.
    public: GazeboIMUPlugin();

    /// \brief Destructor.
    public: virtual ~GazeboIMUPlugin();

    /// \brief Load the sensor plugin.
    /// \param[in] _sensor Pointer to the sensor that loaded this plugin.
    /// \param[in] _sdf SDF element that describes the plugin.
    public: virtual void Load(sensors::SensorPtr _sensor, sdf::ElementPtr _sdf);

    /// \brief Callback that recieves the contact sensor's update signal.
    private: virtual void OnUpdate();

    /// \brief Pointer to the contact sensor
    private: sensors::ImuSensorPtr parentSensor;

    /// \brief Connection that maintains a link between the contact sensor's
    /// updated signal and the OnUpdate callback.
    private: event::ConnectionPtr updateConnection;

    // Simulated acceleration (my_imu)
    private:
    double m_acc_x;
    double m_acc_y;
    double m_acc_z;
    
    // Simulated angular velocity (my_imu)
    private:
    double m_omega_x;
    double m_omega_y;
    double m_omega_z;

  };
}
#endif
