#include "mainvars.h"
#include <math.h>

#include "pid.h"

void set_Kp(double p) {
   Kp = p;
}
 
void set_Ki(double i) {
   Ki = i;
}
 
void set_Kd(double d) {
   Kd = d;
}
 
//void output(double y){
//   _send_dac(y); //Beispielfunktion zum Senden eines Analogsignals für die Stellgröße y
//}
 
int get_sensor(){
   return _get_adc(); //Beispielfunktion zum Auslesen eines analogen Sensorsignals
}
 
int pid(double sollwert, double istwert){
    static int esum = 0, e_alt = 0; //esum ist die Summierung aller Regelabweichungen, e_alt die vorherige Regelabweichung
    int y_p, y_i, y_d, y_gesamt; //Die einzelnen Stellgrößen und die Gesamtstellgröße
    int e; //Die Regelabweichung
 
    e = sollwert - istwert; //Berechnung der Regelabweichung nach e(t) = w(t) - x(t)
 
    y_p = Kp * e; //Der Proportional-Anteil nach y(t) = Kp * e(t)
 
    esum = esum + e; //Jede Regelabweichung wird durch das Integral über die Zeit aufsummiert
    y_i = Ki * esum; //Der Integral-Anteil nach y(t) = Ki * e(t)
 
    y_d = Kd * (e_alt - e); //Der Differential-Anteil nach y(t) = Kd * (d e(t) / dt)
    e_alt = e; //Der Durchlauf ist beendet, die aktuelle Regelabweichung ist die alte für den nächsten Durchlauf
 
    y_gesamt = y_p + y_i + y_d; //Alle Stellgrößen zur Gesamtstellgröße addieren
 
    return y_gesamt; //und diese zurückgegben
}
