#include <math.h>
#include "backstepping.h"

void backsteppingInit(BackSteppingObject* backstepping, const float desired, const float l, const float J, const float a1, const float a2)
{
  backstepping->error     = 0;
  backstepping->prevError = 0;
  backstepping->a1        = a1;
  backstepping->a2        = a2;
  backstepping->J	  = J;
  backstepping->l         = l;
  backstepping->desired   = desired;
  //TODO: Plausiblitätstests für Stellwerte setzen
}

float backsteppingUpdate(BackSteppingObject* backstepping, const float measured, const float omega, const bool updateError)
{
    float output;

    if (updateError)
    {
        backstepping->error = backstepping->desired - measured;
    }
  
    output = ( backstepping->J / backstepping->l ) * ( ( 1 + backstepping->a1*backstepping->a2 )*backstepping->error - ( backstepping->a1 + backstepping->a2 )*omega );

/*
    output = backstepping->out;

    backstepping->prevError = backstepping->error;
*/
    return output;
}

void backsteppingReset(BackSteppingObject* backstepping)
{
  backstepping->error     = 0;
  backstepping->prevError = 0;
}

void backsteppingSetError(BackSteppingObject* backstepping, const float error)
{
  backstepping->error = error;
}

void backsteppingSetDesired(BackSteppingObject* backstepping, const float desired)
{
  backstepping->desired = desired;
}

float backsteppingGetDesired(BackSteppingObject* backstepping)
{
  return backstepping->desired;
}
